OGRE: Ogre::Entity Class Reference - OGRE Documentation

# Ogre::Entity Class Reference

Defines an instance of a discrete, movable object based on a Mesh. More...

`#include <OgreEntity.h>`

Inheritance diagram for Ogre::Entity:

[legend]

List of all members.

## Public Types
enum | VertexDataBindChoice { BIND_ORIGINAL, BIND_SOFTWARE_SKELETAL, BIND_SOFTWARE_MORPH, BIND_HARDWARE_MORPH }
| Identify which vertex data we should be sending to the renderer. More...
typedef std::set< Entity * > | EntitySet
typedef std::map< String, MovableObject * > | ChildObjectList
| Contains the child objects (attached to bones) indexed by name.
typedef MapIterator < ChildObjectList > | ChildObjectListIterator
typedef std::vector < ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator < ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| ~Entity ()
| Default destructor.
const MeshPtr & | getMesh (void) const
| Gets the Mesh that this Entity is based on.
SubEntity * | getSubEntity (unsigned int index) const
| Gets a pointer to a SubEntity, ie a part of an Entity.
SubEntity * | getSubEntity (const String &name) const
| Gets a pointer to a SubEntity by name.
unsigned int | getNumSubEntities (void) const
| Retrieves the number of SubEntity objects making up this entity.
Entity * | clone (const String &newName) const
| Clones this entity and returns a pointer to the clone.
void | setMaterialName (const String &name)
| Sets the material to use for the whole of this entity.
void | setMaterial (const MaterialPtr &material)
| Sets the material to use for the whole of this entity.
void | _notifyCurrentCamera (Camera *cam)
| Overridden - see MovableObject.
void | setRenderQueueGroup (uint8 queueID)
| Overridden - see MovableObject.
const AxisAlignedBox & | getBoundingBox (void) const
| Overridden - see MovableObject.
AxisAlignedBox | getChildObjectsBoundingBox (void) const
| merge all the child object Bounds a return it
void | _updateRenderQueue (RenderQueue *queue)
| Overridden - see MovableObject.
const String & | getMovableType (void) const
| Overridden from MovableObject.
AnimationState * | getAnimationState (const String &name) const
| For entities based on animated meshes, gets the AnimationState object for a single animation.
AnimationStateSet * | getAllAnimationStates (void) const
| For entities based on animated meshes, gets the AnimationState objects for all animations.
void | setDisplaySkeleton (bool display)
| Tells the Entity whether or not it should display it's skeleton, if it has one.
bool | getDisplaySkeleton (void) const
| Returns whether or not the entity is currently displaying its skeleton.
Entity * | getManualLodLevel (size_t index) const
| Gets a pointer to the entity representing the numbered manual level of detail.
size_t | getNumManualLodLevels (void) const
| Returns the number of manual levels of detail that this entity supports.
ushort | getCurrentLodIndex ()
| Returns the current LOD used to render.
void | setMeshLodBias (Real factor, ushort maxDetailIndex=0, ushort minDetailIndex=99)
| Sets a level-of-detail bias for the mesh detail of this entity.
void | setMaterialLodBias (Real factor, ushort maxDetailIndex=0, ushort minDetailIndex=99)
| Sets a level-of-detail bias for the material detail of this entity.
void | setPolygonModeOverrideable (bool PolygonModeOverrideable)
| Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings.
TagPoint * | attachObjectToBone (const String &boneName, MovableObject *pMovable, const Quaternion &offsetOrientation=Quaternion::IDENTITY, const Vector3 &offsetPosition=Vector3::ZERO)
| Attaches another object to a certain bone of the skeleton which this entity uses.
MovableObject * | detachObjectFromBone (const String &movableName)
| Detach a MovableObject previously attached using attachObjectToBone.
void | detachObjectFromBone (MovableObject *obj)
| Detaches an object by pointer.
void | detachAllObjectsFromBone (void)
| Detach all MovableObjects previously attached using attachObjectToBone.
ChildObjectListIterator | getAttachedObjectIterator (void)
| Gets an iterator to the list of objects attached to bones on this entity.
Real | getBoundingRadius (void) const
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| MovableObject::getWorldBoundingBox
const Sphere & | getWorldBoundingSphere (bool derive=false) const
| MovableObject::getWorldBoundingSphere
EdgeData * | getEdgeList (void)
| Overridden member from ShadowCaster.
bool | hasEdgeList (void)
| Overridden member from ShadowCaster.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)
| Overridden member from ShadowCaster.
const Matrix4 * | _getBoneMatrices (void) const
| Internal method for retrieving bone matrix information.
unsigned short | _getNumBoneMatrices (void) const
| Internal method for retrieving bone matrix information.
bool | hasSkeleton (void) const
| Returns whether or not this entity is skeletally animated.
SkeletonInstance * | getSkeleton (void) const
| Get this Entity's personal skeleton instance.
bool | isHardwareAnimationEnabled (void) const
| Returns whether or not hardware animation is enabled.
void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Overridden from MovableObject.
int | getSoftwareAnimationRequests (void) const
| Returns the number of requests that have been made for software animation.
int | getSoftwareAnimationNormalsRequests (void) const
| Returns the number of requests that have been made for software animation of normals.
void | addSoftwareAnimationRequest (bool normalsAlso)
| Add a request for software animation.
void | removeSoftwareAnimationRequest (bool normalsAlso)
| Removes a request for software animation.
void | shareSkeletonInstanceWith (Entity *entity)
| Shares the SkeletonInstance with the supplied entity.
bool | hasVertexAnimation (void) const
| Returns whether or not this entity is either morph or pose animated.
void | stopSharingSkeletonInstance ()
| Stops sharing the SkeletonInstance with other entities.
bool | sharesSkeletonInstance () const
| Returns whether this entity shares it's SkeltonInstance with other entity instances.
const EntitySet * | getSkeletonInstanceSharingSet () const
| Returns a pointer to the set of entities which share a SkeletonInstance.
void | refreshAvailableAnimationState (void)
| Updates the internal animation state set to include the latest available animations from the attached skeleton.
void | _updateAnimation (void)
| Advanced method to perform all the updates required for an animated entity.
bool | _isAnimated (void) const
| Tests if any animation applied to this entity.
bool | _isSkeletonAnimated (void) const
| Tests if skeleton was animated.
VertexData * | _getSkelAnimVertexData (void) const
| Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned.
VertexData * | _getSoftwareVertexAnimVertexData (void) const
| Advanced method to get the temporarily blended software vertex animation information.
VertexData * | _getHardwareVertexAnimVertexData (void) const
| Advanced method to get the hardware morph vertex information.
TempBlendedBufferInfo * | _getSkelAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software skeletal animation.
TempBlendedBufferInfo * | _getVertexAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software morph animation.
uint32 | getTypeFlags (void) const
| Override to return specific type flag.
VertexData * | getVertexDataForBinding (void)
| Retrieve the VertexData which should be used for GPU binding.
VertexDataBindChoice | chooseVertexDataForBinding (bool hasVertexAnim) const
| Choose which vertex data to bind to the renderer.
bool | _getBuffersMarkedForAnimation (void) const
| Are buffers already marked as vertex animated?
void | _markBuffersUsedForAnimation (void)
| Mark just this vertex data as animated.
bool | isInitialised (void) const
| Has this Entity been initialised yet?
void | _initialise (bool forceReinitialise=false)
| Try to initialise the Entity from the underlying resources.
void | _deinitialise (void)
| Tear down the internal structures of this Entity, rendering it uninitialised.
void | backgroundLoadingComplete (Resource *res)
| Resource::Listener hook to notify Entity that a delay-loaded Mesh is complete.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
  | Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any. Parameters:
  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual void | detatchFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
virtual LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
virtual bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
virtual void | backgroundPreparingComplete (Resource *)
| Callback to indicate that background preparing has completed.
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Protected Types
typedef std::vector< SubEntity * > | SubEntityList
| List of SubEntities (point to SubMeshes).
typedef std::vector< Entity * > | LODEntityList
| List of LOD Entity instances (for manual LODs).
typedef std::map< String, StringVector > | AnimableDictionaryMap
## Protected Member Functions
| Entity ()
| Private constructor (instances cannot be created directly).
| Entity (const String &name, const MeshPtr &mesh)
| Private constructor - specify name (the usual constructor used).
const VertexData * | findBlendedVertexData (const VertexData *orig)
| Internal method - given vertex data which could be from the Mesh or any submesh, finds the temporary blend copy.
SubEntity * | findSubEntityForVertexData (const VertexData *orig)
| Internal method - given vertex data which could be from the Mesh or any SubMesh, finds the corresponding SubEntity.
void | extractTempBufferInfo (VertexData *sourceData, TempBlendedBufferInfo *info)
| Internal method for extracting metadata out of source vertex data for fast assignment of temporary buffers later.
VertexData * | cloneVertexDataRemoveBlendInfo (const VertexData *source)
| Internal method to clone vertex data definitions but to remove blend buffers.
void | prepareTempBlendBuffers (void)
| Internal method for preparing this Entity for use in animation.
void | markBuffersUnusedForAnimation (void)
| Mark all vertex data as so far unanimated.
void | restoreBuffersForUnusedAnimation (bool hardwareAnimation)
| Internal method to restore original vertex data where we didn't perform any vertex animation this frame.
void | bindMissingHardwarePoseBuffers (const VertexData *srcData, VertexData *destData)
| Ensure that any unbound pose animation buffers are bound to a safe default.
void | updateAnimation (void)
| Perform all the updates required for an animated entity.
void | cacheBoneMatrices (void)
| Private method to cache bone matrices from skeleton.
void | buildSubEntityList (MeshPtr &mesh, SubEntityList *sublist)
| Builds a list of SubEntities based on the SubMeshes contained in the Mesh.
void | attachObjectImpl (MovableObject *pMovable, TagPoint *pAttachingPoint)
| internal implementation of attaching a 'child' object to this entity and assign the parent node to the child entity
void | detachObjectImpl (MovableObject *pObject)
| internal implementation of detaching a 'child' object of this entity and clear the parent node of the child entity
void | detachAllObjectsImpl (void)
| internal implementation of detaching all 'child' objects of this entity
void | reevaluateVertexProcessing (void)
| Trigger reevaluation of the kind of vertex processing in use.
void | applyVertexAnimation (bool hardwareAnimation, bool stencilShadows)
| Apply vertex animation.
void | initHardwareAnimationElements (VertexData *vdata, ushort numberOfElements)
| Initialise the hardware animation elements for given vertex data.
bool | tempVertexAnimBuffersBound (void) const
| Are software vertex animation temp buffers bound?
bool | tempSkelAnimBuffersBound (bool requestNormals) const
| Are software skeleton animation temp buffers bound?
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper method for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
MeshPtr | mMesh
| The Mesh that this Entity is based on.
SubEntityList | mSubEntityList
AnimationStateSet * | mAnimationState
| State of animation for animable meshes.
TempBlendedBufferInfo | mTempSkelAnimInfo
| Temp buffer details for software skeletal anim of shared geometry.
VertexData * | mSkelAnimVertexData
| Vertex data details for software skeletal anim of shared geometry.
TempBlendedBufferInfo | mTempVertexAnimInfo
| Temp buffer details for software vertex anim of shared geometry.
VertexData * | mSoftwareVertexAnimVertexData
| Vertex data details for software vertex anim of shared geometry.
VertexData * | mHardwareVertexAnimVertexData
| Vertex data details for hardware vertex anim of shared geometry separate since we need to s/w anim for shadows whilst still altering the vertex data for hardware morphing (pos2 binding).
bool | mVertexAnimationAppliedThisFrame
| Have we applied any vertex animation to shared geometry?
bool | mPreparedForShadowVolumes
| Have the temp buffers already had their geometry prepared for use in rendering shadow volumes?
Matrix4 * | mBoneWorldMatrices
| Cached bone matrices, including any world transform.
Matrix4 * | mBoneMatrices
| Cached bone matrices in skeleton local space, might shares with other entity instances.
unsigned short | mNumBoneMatrices
unsigned long | mFrameAnimationLastUpdated
| Records the last frame in which animation was updated.
unsigned long * | mFrameBonesLastUpdated
| Records the last frame in which the bones was updated It's a pointer because it can be shared between different entities with a shared skeleton.
EntitySet * | mSharedSkeletonEntities
| A set of all the entities which shares a single SkeletonInstance.
bool | mDisplaySkeleton
| Flag determines whether or not to display skeleton.
bool | mHardwareAnimation
| Flag indicating whether hardware animation is supported by this entities materials.
ushort | mHardwarePoseCount
| Number of hardware poses supported by materials.
bool | mVertexProgramInUse
| Flag indicating whether we have a vertex program in use on any of our subentities.
int | mSoftwareAnimationRequests
| Counter indicating number of requests for software animation.
int | mSoftwareAnimationNormalsRequests
| Counter indicating number of requests for software blended normals.
ushort | mMeshLodIndex
| The LOD number of the mesh to use, calculated by _notifyCurrentCamera.
Real | mMeshLodFactorInv
| LOD bias factor, inverted for optimisation when calculating adjusted depth.
ushort | mMinMeshLodIndex
| Index of minimum detail LOD (NB higher index is lower detail).
ushort | mMaxMeshLodIndex
| Index of maximum detail LOD (NB lower index is higher detail).
Real | mMaterialLodFactorInv
| LOD bias factor, inverted for optimisation when calculating adjusted depth.
ushort | mMinMaterialLodIndex
| Index of minimum detail LOD (NB higher index is lower detail).
ushort | mMaxMaterialLodIndex
| Index of maximum detail LOD (NB lower index is higher detail).
LODEntityList | mLodEntityList
SkeletonInstance * | mSkeletonInstance
| This Entity's personal copy of the skeleton, if skeletally animated.
bool | mInitialised
| Has this entity been initialised yet?
Matrix4 | mLastParentXform
| Last parent xform.
size_t | mMeshStateCount
| Mesh state count, used to detect differences.
ChildObjectList | mChildObjectList
AxisAlignedBox | mFullBoundingBox
| Bounding box that 'contains' all the mesh of each child entity.
ShadowRenderableList | mShadowRenderables
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
bool | mDebugDisplay
| Is debug display enabled?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
## Static Protected Attributes
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.
## Friends
class | EntityFactory
class | SubEntity
## Classes
class | EntityShadowRenderable
| Nested class to allow entity shadows. More...

## Detailed Description

Defines an instance of a discrete, movable object based on a Mesh.

Remarks:
  Ogre generally divides renderable objects into 2 groups, discrete (separate) and relatively small objects which move around the world, and large, sprawling geometry which makes up generally immovable scenery, aka 'level geometry'.

  The Mesh and SubMesh classes deal with the definition of the geometry used by discrete movable objects. Entities are actual instances of objects based on this geometry in the world. Therefore there is usually a single set Mesh for a car, but there may be multiple entities based on it in the world. Entities are able to override aspects of the Mesh it is defined by, such as changing material properties per instance (so you can have many cars using the same geometry but different textures for example). Because a Mesh is split into SubMeshes for this purpose, the Entity class is a grouping class (much like the Mesh class) and much of the detail regarding individual changes is kept in the SubEntity class. There is a 1:1 relationship between SubEntity instances and the SubMesh instances associated with the Mesh the Entity is based on.

  Entity and SubEntity classes are never created directly. Use the createEntity method of the SceneManager (passing a model name) to create one.

  Entities are included in the scene by associating them with a SceneNode, using the attachEntity method. See the SceneNode class for full information.

Note:
  No functions were declared virtual to improve performance.

Definition at line 75 of file OgreEntity.h.

## Member Typedef Documentation

typedef std::set<Entity*> Ogre::Entity::EntitySet

Definition at line 81 of file OgreEntity.h.

typedef std::vector<SubEntity*> Ogre::Entity::SubEntityList`[protected]`

List of SubEntities (point to SubMeshes).

Definition at line 98 of file OgreEntity.h.

typedef std::vector<Entity*> Ogre::Entity::LODEntityList`[protected]`

List of LOD Entity instances (for manual LODs).

We don't know when the mesh is using manual LODs whether one LOD to the next will have the same number of SubMeshes, therefore we have to allow a separate Entity list with each alternate one.

Definition at line 215 of file OgreEntity.h.

typedef std::map<String, MovableObject*> Ogre::Entity::ChildObjectList

Contains the child objects (attached to bones) indexed by name.

Definition at line 258 of file OgreEntity.h.

typedef MapIterator<ChildObjectList> Ogre::Entity::ChildObjectListIterator

Definition at line 516 of file OgreEntity.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

Definition at line 123 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

Definition at line 124 of file OgreShadowCaster.h.

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

Definition at line 234 of file OgreAnimable.h.

## Member Enumeration Documentation

enum Ogre::Entity::VertexDataBindChoice

Identify which vertex data we should be sending to the renderer.

Enumerator:

  BIND_ORIGINAL |
  BIND_SOFTWARE_SKELETAL |
  BIND_SOFTWARE_MORPH |
  BIND_HARDWARE_MORPH |

Definition at line 703 of file OgreEntity.h.

## Constructor & Destructor Documentation

Ogre::Entity::Entity | ( |  | ) | `[protected]`

Private constructor (instances cannot be created directly).

Ogre::Entity::Entity | ( | const String & | name,
|  | const MeshPtr & | mesh |
| ) |  |  | `[protected]`

Private constructor - specify name (the usual constructor used).

Ogre::Entity::~Entity | ( |  | ) |

Default destructor.

## Member Function Documentation

const VertexData* Ogre::Entity::findBlendedVertexData | ( | const VertexData * | orig | ) | `[protected]`

Internal method - given vertex data which could be from the Mesh or any submesh, finds the temporary blend copy.

SubEntity* Ogre::Entity::findSubEntityForVertexData | ( | const VertexData * | orig | ) | `[protected]`

Internal method - given vertex data which could be from the Mesh or any SubMesh, finds the corresponding SubEntity.

void Ogre::Entity::extractTempBufferInfo | ( | VertexData * | sourceData,
|  | TempBlendedBufferInfo * | info |
| ) |  |  | `[protected]`

Internal method for extracting metadata out of source vertex data for fast assignment of temporary buffers later.

VertexData* Ogre::Entity::cloneVertexDataRemoveBlendInfo | ( | const VertexData * | source | ) | `[protected]`

Internal method to clone vertex data definitions but to remove blend buffers.

void Ogre::Entity::prepareTempBlendBuffers | ( | void |  | ) | `[protected]`

Internal method for preparing this Entity for use in animation.

void Ogre::Entity::markBuffersUnusedForAnimation | ( | void |  | ) | `[protected]`

Mark all vertex data as so far unanimated.

void Ogre::Entity::restoreBuffersForUnusedAnimation | ( | bool | hardwareAnimation | ) | `[protected]`

Internal method to restore original vertex data where we didn't perform any vertex animation this frame.

void Ogre::Entity::bindMissingHardwarePoseBuffers | ( | const VertexData * | srcData,
|  | VertexData * | destData |
| ) |  |  | `[protected]`

Ensure that any unbound pose animation buffers are bound to a safe default.

Parameters:

  | srcData | Original vertex data containing original positions
  | destData | Hardware animation vertex data to be checked

void Ogre::Entity::updateAnimation | ( | void |  | ) | `[protected]`

Perform all the updates required for an animated entity.

void Ogre::Entity::cacheBoneMatrices | ( | void |  | ) | `[protected]`

Private method to cache bone matrices from skeleton.

void Ogre::Entity::buildSubEntityList | ( | MeshPtr & | mesh,
|  | SubEntityList * | sublist |
| ) |  |  | `[protected]`

Builds a list of SubEntities based on the SubMeshes contained in the Mesh.

void Ogre::Entity::attachObjectImpl | ( | MovableObject * | pMovable,
|  | TagPoint * | pAttachingPoint |
| ) |  |  | `[protected]`

internal implementation of attaching a 'child' object to this entity and assign the parent node to the child entity

void Ogre::Entity::detachObjectImpl | ( | MovableObject * | pObject | ) | `[protected]`

internal implementation of detaching a 'child' object of this entity and clear the parent node of the child entity

void Ogre::Entity::detachAllObjectsImpl | ( | void |  | ) | `[protected]`

internal implementation of detaching all 'child' objects of this entity

void Ogre::Entity::reevaluateVertexProcessing | ( | void |  | ) | `[protected]`

Trigger reevaluation of the kind of vertex processing in use.

void Ogre::Entity::applyVertexAnimation | ( | bool | hardwareAnimation,
|  | bool | stencilShadows |
| ) |  |  | `[protected]`

Apply vertex animation.

void Ogre::Entity::initHardwareAnimationElements | ( | VertexData * | vdata,
|  | ushort | numberOfElements |
| ) |  |  | `[protected]`

Initialise the hardware animation elements for given vertex data.

bool Ogre::Entity::tempVertexAnimBuffersBound | ( | void |  | ) | const`[protected]`

Are software vertex animation temp buffers bound?

bool Ogre::Entity::tempSkelAnimBuffersBound | ( | bool | requestNormals | ) | const`[protected]`

Are software skeleton animation temp buffers bound?

const MeshPtr& Ogre::Entity::getMesh | ( | void |  | ) | const

Gets the Mesh that this Entity is based on.

SubEntity* Ogre::Entity::getSubEntity | ( | unsigned int | index | ) | const

Gets a pointer to a SubEntity, ie a part of an Entity.

SubEntity* Ogre::Entity::getSubEntity | ( | const String & | name | ) | const

Gets a pointer to a SubEntity by name.

Remarks:
  - names should be initialized during a Mesh creation.

unsigned int Ogre::Entity::getNumSubEntities | ( | void |  | ) | const

Retrieves the number of SubEntity objects making up this entity.

Entity* Ogre::Entity::clone | ( | const String & | newName | ) | const

Clones this entity and returns a pointer to the clone.

Remarks:
  Useful method for duplicating an entity. The new entity must be given a unique name, and is not attached to the scene in any way so must be attached to a SceneNode to be visible (exactly as entities returned from SceneManager::createEntity).

Parameters:

  | newName | Name for the new entity.

void Ogre::Entity::setMaterialName | ( | const String & | name | ) |

Sets the material to use for the whole of this entity.

Remarks:
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

void Ogre::Entity::setMaterial | ( | const MaterialPtr & | material | ) |

Sets the material to use for the whole of this entity.

Remarks:
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

void Ogre::Entity::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Overridden - see MovableObject.

Reimplemented from Ogre::MovableObject.

void Ogre::Entity::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual]`

Overridden - see MovableObject.

Reimplemented from Ogre::MovableObject.

const AxisAlignedBox& Ogre::Entity::getBoundingBox | ( | void |  | ) | const`[virtual]`

Overridden - see MovableObject.

Implements Ogre::MovableObject.

AxisAlignedBox Ogre::Entity::getChildObjectsBoundingBox | ( | void |  | ) | const

merge all the child object Bounds a return it

void Ogre::Entity::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Overridden - see MovableObject.

Implements Ogre::MovableObject.

const String& Ogre::Entity::getMovableType | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

AnimationState* Ogre::Entity::getAnimationState | ( | const String & | name | ) | const

For entities based on animated meshes, gets the AnimationState object for a single animation.

Remarks:
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

AnimationStateSet* Ogre::Entity::getAllAnimationStates | ( | void |  | ) | const

For entities based on animated meshes, gets the AnimationState objects for all animations.

Returns:
  In case the entity is animated, this functions returns the pointer to a AnimationStateSet containing all animations of the entries. If the entity is not animated, it returns 0.

Remarks:
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

void Ogre::Entity::setDisplaySkeleton | ( | bool | display | ) |

Tells the Entity whether or not it should display it's skeleton, if it has one.

bool Ogre::Entity::getDisplaySkeleton | ( | void |  | ) | const

Returns whether or not the entity is currently displaying its skeleton.

Entity* Ogre::Entity::getManualLodLevel | ( | size_t | index | ) | const

Gets a pointer to the entity representing the numbered manual level of detail.

Remarks:
  The zero-based index never includes the original entity, unlike Mesh::getLodLevel.

size_t Ogre::Entity::getNumManualLodLevels | ( | void |  | ) | const

Returns the number of manual levels of detail that this entity supports.

Remarks:
  This number never includes the original entity, it is difference with Mesh::getNumLodLevels.

ushort Ogre::Entity::getCurrentLodIndex | ( |  | ) |

Returns the current LOD used to render.

Definition at line 418 of file OgreEntity.h.

void Ogre::Entity::setMeshLodBias | ( | Real | factor,
|  | ushort | maxDetailIndex = `0`,
|  | ushort | minDetailIndex = `99` |
| ) |  |  |

Sets a level-of-detail bias for the mesh detail of this entity.

Remarks:
  Level of detail reduction is normally applied automatically based on the Mesh settings. However, it is possible to influence this behaviour for this entity by adjusting the LOD bias. This 'nudges' the mesh level of detail used for this entity up or down depending on your requirements. You might want to use this if there was a particularly important entity in your scene which you wanted to detail better than the others, such as a player model.

  There are three parameters to this method; the first is a factor to apply; it defaults to 1.0 (no change), by increasing this to say 2.0, this model would take twice as long to reduce in detail, whilst at 0.5 this entity would use lower detail versions twice as quickly. The other 2 parameters are hard limits which let you set the maximum and minimum level-of-detail version to use, after all other calculations have been made. This lets you say that this entity should never be simplified, or that it can only use LODs below a certain level even when right next to the camera.

Parameters:

  | factor | Proportional factor to apply to the distance at which LOD is changed. Higher values increase the distance at which higher LODs are displayed (2.0 is twice the normal distance, 0.5 is half).
  | maxDetailIndex | The index of the maximum LOD this entity is allowed to use (lower indexes are higher detail: index 0 is the original full detail model).
  | minDetailIndex | The index of the minimum LOD this entity is allowed to use (higher indexes are lower detail). Use something like 99 if you want unlimited LODs (the actual LOD will be limited by the number in the Mesh)

void Ogre::Entity::setMaterialLodBias | ( | Real | factor,
|  | ushort | maxDetailIndex = `0`,
|  | ushort | minDetailIndex = `99` |
| ) |  |  |

Sets a level-of-detail bias for the material detail of this entity.

Remarks:
  Level of detail reduction is normally applied automatically based on the Material settings. However, it is possible to influence this behaviour for this entity by adjusting the LOD bias. This 'nudges' the material level of detail used for this entity up or down depending on your requirements. You might want to use this if there was a particularly important entity in your scene which you wanted to detail better than the others, such as a player model.

  There are three parameters to this method; the first is a factor to apply; it defaults to 1.0 (no change), by increasing this to say 2.0, this entity would take twice as long to use a lower detail material, whilst at 0.5 this entity would use lower detail versions twice as quickly. The other 2 parameters are hard limits which let you set the maximum and minimum level-of-detail index to use, after all other calculations have been made. This lets you say that this entity should never be simplified, or that it can only use LODs below a certain level even when right next to the camera.

Parameters:

  | factor | Proportional factor to apply to the distance at which LOD is changed. Higher values increase the distance at which higher LODs are displayed (2.0 is twice the normal distance, 0.5 is half).
  | maxDetailIndex | The index of the maximum LOD this entity is allowed to use (lower indexes are higher detail: index 0 is the original full detail model).
  | minDetailIndex | The index of the minimum LOD this entity is allowed to use (higher indexes are lower detail. Use something like 99 if you want unlimited LODs (the actual LOD will be limited by the number of lod indexes used in the Material)

void Ogre::Entity::setPolygonModeOverrideable | ( | bool | PolygonModeOverrideable | ) |

Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings.

TagPoint* Ogre::Entity::attachObjectToBone | ( | const String & | boneName,
|  | MovableObject * | pMovable,
|  | const Quaternion & | offsetOrientation = `Quaternion::IDENTITY`,
|  | const Vector3 & | offsetPosition = `Vector3::ZERO` |
| ) |  |  |

Attaches another object to a certain bone of the skeleton which this entity uses.

Remarks:
  This method can be used to attach another object to an animated part of this entity, by attaching it to a bone in the skeleton (with an offset if required). As this entity is animated, the attached object will move relative to the bone to which it is attached.

  An exception is thrown if the movable object is already attached to the bone, another bone or scenenode. If the entity has no skeleton or the bone name cannot be found then an exception is thrown.

Parameters:

  | boneName | The name of the bone (in the skeleton) to attach this object
  | pMovable | Pointer to the object to attach
  | offsetOrientation | An adjustment to the orientation of the attached object, relative to the bone.
  | offsetPosition | An adjustment to the position of the attached object, relative to the bone.

Returns:
  The TagPoint to which the object has been attached

MovableObject* Ogre::Entity::detachObjectFromBone | ( | const String & | movableName | ) |

Detach a MovableObject previously attached using attachObjectToBone.

If the movable object name is not found then an exception is raised.

Parameters:

  | movableName | is the name of the movable object to be detached.

void Ogre::Entity::detachObjectFromBone | ( | MovableObject * | obj | ) |

Detaches an object by pointer.

Remarks:
  Use this method to destroy a MovableObject which is attached to a bone of belonging this entity. But sometimes the object may be not in the child object list because it is a lod entity, this method can safely detect and ignore in this case and won't raise an exception.

void Ogre::Entity::detachAllObjectsFromBone | ( | void |  | ) |

Detach all MovableObjects previously attached using attachObjectToBone.

ChildObjectListIterator Ogre::Entity::getAttachedObjectIterator | ( | void |  | ) |

Gets an iterator to the list of objects attached to bones on this entity.

Real Ogre::Entity::getBoundingRadius | ( | void |  | ) | const`[virtual]`

See also:
  MovableObject::getBoundingRadius

Implements Ogre::MovableObject.

const AxisAlignedBox& Ogre::Entity::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual]`

MovableObject::getWorldBoundingBox

Reimplemented from Ogre::MovableObject.

const Sphere& Ogre::Entity::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual]`

MovableObject::getWorldBoundingSphere

Reimplemented from Ogre::MovableObject.

EdgeData* Ogre::Entity::getEdgeList | ( | void |  | ) | `[virtual]`

Overridden member from ShadowCaster.

Reimplemented from Ogre::MovableObject.

bool Ogre::Entity::hasEdgeList | ( | void |  | ) | `[virtual]`

Overridden member from ShadowCaster.

Reimplemented from Ogre::MovableObject.

ShadowRenderableListIterator Ogre::Entity::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDistance,
|  | unsigned long | flags = `0` |
| ) |  |  | `[virtual]`

Overridden member from ShadowCaster.

Reimplemented from Ogre::MovableObject.

const Matrix4* Ogre::Entity::_getBoneMatrices | ( | void |  | ) | const

Internal method for retrieving bone matrix information.

Definition at line 538 of file OgreEntity.h.

unsigned short Ogre::Entity::_getNumBoneMatrices | ( | void |  | ) | const

Internal method for retrieving bone matrix information.

Definition at line 540 of file OgreEntity.h.

bool Ogre::Entity::hasSkeleton | ( | void |  | ) | const

Returns whether or not this entity is skeletally animated.

Definition at line 542 of file OgreEntity.h.

SkeletonInstance* Ogre::Entity::getSkeleton | ( | void |  | ) | const

Get this Entity's personal skeleton instance.

Definition at line 544 of file OgreEntity.h.

bool Ogre::Entity::isHardwareAnimationEnabled | ( | void |  | ) | const

Returns whether or not hardware animation is enabled.

Remarks:
  Because fixed-function indexed vertex blending is rarely supported by existing graphics cards, hardware animation can only be done if the vertex programs in the materials used to render an entity support it. Therefore, this method will only return true if all the materials assigned to this entity have vertex programs assigned, and all those vertex programs must support 'includes_morph_animation true' if using morph animation, 'includes_pose_animation true' if using pose animation and 'includes_skeletal_animation true' if using skeletal animation.

Definition at line 556 of file OgreEntity.h.

void Ogre::Entity::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual]`

Overridden from MovableObject.

Reimplemented from Ogre::MovableObject.

int Ogre::Entity::getSoftwareAnimationRequests | ( | void |  | ) | const

Returns the number of requests that have been made for software animation.

Remarks:
  If non-zero then software animation will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Requests for software animation are made by calling the addSoftwareAnimationRequest() method.

Definition at line 567 of file OgreEntity.h.

int Ogre::Entity::getSoftwareAnimationNormalsRequests | ( | void |  | ) | const

Returns the number of requests that have been made for software animation of normals.

Remarks:
  If non-zero, and getSoftwareAnimationRequests() also returns non-zero, then software animation of normals will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Currently it is not possible to force software animation of only normals. Consequently this value is always less than or equal to that returned by getSoftwareAnimationRequests(). Requests for software animation of normals are made by calling the addSoftwareAnimationRequest() method with 'true' as the parameter.

Definition at line 579 of file OgreEntity.h.

void Ogre::Entity::addSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Add a request for software animation.

Remarks:
  Tells the entity to perform animation calculations for skeletal/vertex animations in software, regardless of the current setting of isHardwareAnimationEnabled(). Software animation will be performed any time one or more requests have been made. If 'normalsAlso' is 'true', then the entity will also do software blending on normal vectors, in addition to positions. This advanced method useful for situations in which access to actual mesh vertices is required, such as accurate collision detection or certain advanced shading techniques. When software animation is no longer needed, the caller of this method should always remove the request by calling removeSoftwareAnimationRequest(), passing the same value for 'normalsAlso'.

void Ogre::Entity::removeSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Removes a request for software animation.

Remarks:
  Calling this decrements the entity's internal counter of the number of requests for software animation. If the counter is already zero then calling this method throws an exception. The 'normalsAlso' flag if set to 'true' will also decrement the internal counter of number of requests for software animation of normals.

void Ogre::Entity::shareSkeletonInstanceWith | ( | Entity * | entity | ) |

Shares the SkeletonInstance with the supplied entity.

Note that in order for this to work, both entities must have the same Skeleton.

bool Ogre::Entity::hasVertexAnimation | ( | void |  | ) | const

Returns whether or not this entity is either morph or pose animated.

void Ogre::Entity::stopSharingSkeletonInstance | ( |  | ) |

Stops sharing the SkeletonInstance with other entities.

bool Ogre::Entity::sharesSkeletonInstance | ( |  | ) | const

Returns whether this entity shares it's SkeltonInstance with other entity instances.

Definition at line 625 of file OgreEntity.h.

const EntitySet* Ogre::Entity::getSkeletonInstanceSharingSet | ( |  | ) | const

Returns a pointer to the set of entities which share a SkeletonInstance.

If this instance does not share it's SkeletonInstance with other instances NULL will be returned

Definition at line 631 of file OgreEntity.h.

void Ogre::Entity::refreshAvailableAnimationState | ( | void |  | ) |

Updates the internal animation state set to include the latest available animations from the attached skeleton.

Remarks:
  Use this method if you manually add animations to a skeleton, or have linked the skeleton to another for animation purposes since creating this entity.

Note:
  If you have called getAnimationState prior to calling this method, the pointers will still remain valid.

void Ogre::Entity::_updateAnimation | ( | void |  | ) |

Advanced method to perform all the updates required for an animated entity.

Remarks:
  You don't normally need to call this, but it's here in case you wish to manually update the animation of an Entity at a specific point in time. Animation will not be updated more than once a frame no matter how many times you call this method.

bool Ogre::Entity::_isAnimated | ( | void |  | ) | const

Tests if any animation applied to this entity.

Remarks:
  An entity is animated if any animation state is enabled, or any manual bone applied to the skeleton.

bool Ogre::Entity::_isSkeletonAnimated | ( | void |  | ) | const

Tests if skeleton was animated.

VertexData* Ogre::Entity::_getSkelAnimVertexData | ( | void |  | ) | const

Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned.

Remarks:
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note:
  The positions/normals of the returned vertex data is in object space.

VertexData* Ogre::Entity::_getSoftwareVertexAnimVertexData | ( | void |  | ) | const

Advanced method to get the temporarily blended software vertex animation information.

Remarks:
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note:
  The positions/normals of the returned vertex data is in object space.

VertexData* Ogre::Entity::_getHardwareVertexAnimVertexData | ( | void |  | ) | const

Advanced method to get the hardware morph vertex information.

Note:
  The positions/normals of the returned vertex data is in object space.

TempBlendedBufferInfo* Ogre::Entity::_getSkelAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software skeletal animation.

TempBlendedBufferInfo* Ogre::Entity::_getVertexAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software morph animation.

uint32 Ogre::Entity::getTypeFlags | ( | void |  | ) | const`[virtual]`

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

VertexData* Ogre::Entity::getVertexDataForBinding | ( | void |  | ) |

Retrieve the VertexData which should be used for GPU binding.

VertexDataBindChoice Ogre::Entity::chooseVertexDataForBinding | ( | bool | hasVertexAnim | ) | const

Choose which vertex data to bind to the renderer.

bool Ogre::Entity::_getBuffersMarkedForAnimation | ( | void |  | ) | const

Are buffers already marked as vertex animated?

Definition at line 714 of file OgreEntity.h.

void Ogre::Entity::_markBuffersUsedForAnimation | ( | void |  | ) |

Mark just this vertex data as animated.

bool Ogre::Entity::isInitialised | ( | void |  | ) | const

Has this Entity been initialised yet?

Remarks:
  If this returns false, it means this Entity hasn't been completely constructed yet from the underlying resources (Mesh, Skeleton), which probably means they were delay-loaded and aren't available yet. This Entity won't render until it has been successfully initialised, nor will many of the manipulation methods function.

Definition at line 727 of file OgreEntity.h.

void Ogre::Entity::_initialise | ( | bool | forceReinitialise = `false` | ) |

Try to initialise the Entity from the underlying resources.

Remarks:
  This method builds the internal structures of the Entity based on it resources (Mesh, Skeleton). This may or may not succeed if the resources it references have been earmarked for background loading, so you should check isInitialised afterwards to see if it was sucessful.

Parameters:

  | forceReinitialise | If true, this forces the Entity to tear down it's internal structures and try to rebuild them. Useful if you changed the content of a Mesh or Skeleton at runtime.

void Ogre::Entity::_deinitialise | ( | void |  | ) |

Tear down the internal structures of this Entity, rendering it uninitialised.

void Ogre::Entity::backgroundLoadingComplete | ( | Resource * | res | ) | `[virtual]`

Resource::Listener hook to notify Entity that a delay-loaded Mesh is complete.

Reimplemented from Ogre::Resource::Listener.

void Ogre::Entity::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

Notify the object of it's creator (internal use only).

Definition at line 169 of file OgreMovableObject.h.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

Get the creator of this object, if any (internal use only).

Definition at line 171 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

Notify the object of it's manager (internal use only).

Definition at line 173 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

Get the manager of this object, if any (internal use only).

Definition at line 175 of file OgreMovableObject.h.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

Returns the name of this object.

Reimplemented in Ogre::Camera.

Definition at line 178 of file OgreMovableObject.h.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint.

virtual void Ogre::MovableObject::detatchFromParent | ( | void |  | ) | `[virtual, inherited]`

Detaches an object from a parent SceneNode or TagPoint, if attached.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

Internal method called to notify the object that it has been moved.

Reimplemented in Ogre::Light.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 280 of file OgreMovableObject.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

Gets the distance at which batches are no longer rendered.

Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

Call this to associate your own custom user object instance with this MovableObject.

Remarks:
  By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link.

Definition at line 294 of file OgreMovableObject.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.

Definition at line 298 of file OgreMovableObject.h.

References Ogre::any_cast().

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Note:
  This value is shared with setUserObject so don't use both!

Definition at line 310 of file OgreMovableObject.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Retrieves the custom user value associated with this object.

Definition at line 314 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

Gets the queue group for this entity, see setRenderQueueGroup for full details.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 346 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 350 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the query flags relevant for this object.

Definition at line 353 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default query flags for all future MovableObject instances.

Definition at line 357 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

Get the default query flags for all future MovableObject instances.

Definition at line 361 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 370 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 374 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 378 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the visibility flags relevant for this object.

Definition at line 381 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default visibility flags for all future MovableObject instances.

Definition at line 385 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

Get the default visibility flags for all future MovableObject instances.

Definition at line 389 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 396 of file OgreMovableObject.h.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

Gets the current listener for this object.

Definition at line 400 of file OgreMovableObject.h.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

virtual LightList* Ogre::MovableObject::_getLightList | ( |  | ) | `[virtual, inherited]`

Returns a pointer to the current list of lights for this object.

Remarks:
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

Definition at line 428 of file OgreMovableObject.h.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[virtual, inherited]`

Overridden member from ShadowCaster.

Implements Ogre::ShadowCaster.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 456 of file OgreMovableObject.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

Returns whether shadow casting is enabled for this object.

Implements Ogre::ShadowCaster.

Definition at line 458 of file OgreMovableObject.h.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

Get the distance to extrude for a point/spot light.

Implements Ogre::ShadowCaster.

virtual void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) | `[virtual, inherited]`

Sets whether or not the debug display of this object is enabled.

Remarks:
  Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

Definition at line 495 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const`[virtual, inherited]`

Gets whether debug display of this object is enabled.

Definition at line 497 of file OgreMovableObject.h.

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light |
| ) |  |  | const`[protected, inherited]`

Helper method for calculating extrusion distance.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos |
| ) |  |  | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags |
| ) |  |  | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 242 of file OgreAnimable.h.

References Ogre::StringUtil::BLANK.

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

Internal method for creating a dictionary of animable value names for the class, if it does not already exist.

Definition at line 247 of file OgreAnimable.h.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

Get an updateable reference to animable value list.

Definition at line 260 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

Reimplemented in Ogre::Light.

Definition at line 280 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

Gets a list of animable value names for this object.

Definition at line 288 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

Definition at line 313 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::Resource::Listener::backgroundPreparingComplete | ( | Resource * |  | ) | `[virtual, inherited]`

Callback to indicate that background preparing has completed.

Remarks:
  This callback is only relevant when a Resource has been marked as background loaded (

See also:
  Resource::setBackgroundLoaded) , and occurs when that preparing (but not necessarily loading) has completed. The call does not itself occur in the thread which is doing the preparing; when preparing is complete a response indicator is placed with the ResourceGroupManager, which will then be sent back to the listener as part of the application's primary frame loop thread.

Definition at line 104 of file OgreResource.h.

## Friends And Related Function Documentation

friend class EntityFactory`[friend]`

Definition at line 78 of file OgreEntity.h.

friend class SubEntity`[friend]`

Definition at line 79 of file OgreEntity.h.

## Member Data Documentation

MeshPtr Ogre::Entity::mMesh`[protected]`

The Mesh that this Entity is based on.

Definition at line 94 of file OgreEntity.h.

SubEntityList Ogre::Entity::mSubEntityList`[protected]`

Definition at line 99 of file OgreEntity.h.

AnimationStateSet* Ogre::Entity::mAnimationState`[protected]`

State of animation for animable meshes.

Definition at line 103 of file OgreEntity.h.

TempBlendedBufferInfo Ogre::Entity::mTempSkelAnimInfo`[protected]`

Temp buffer details for software skeletal anim of shared geometry.

Definition at line 107 of file OgreEntity.h.

VertexData* Ogre::Entity::mSkelAnimVertexData`[protected]`

Vertex data details for software skeletal anim of shared geometry.

Definition at line 109 of file OgreEntity.h.

TempBlendedBufferInfo Ogre::Entity::mTempVertexAnimInfo`[protected]`

Temp buffer details for software vertex anim of shared geometry.

Definition at line 111 of file OgreEntity.h.

VertexData* Ogre::Entity::mSoftwareVertexAnimVertexData`[protected]`

Vertex data details for software vertex anim of shared geometry.

Definition at line 113 of file OgreEntity.h.

VertexData* Ogre::Entity::mHardwareVertexAnimVertexData`[protected]`

Vertex data details for hardware vertex anim of shared geometry

- separate since we need to s/w anim for shadows whilst still altering the vertex data for hardware morphing (pos2 binding).

Definition at line 117 of file OgreEntity.h.

bool Ogre::Entity::mVertexAnimationAppliedThisFrame`[protected]`

Have we applied any vertex animation to shared geometry?

Definition at line 119 of file OgreEntity.h.

bool Ogre::Entity::mPreparedForShadowVolumes`[protected]`

Have the temp buffers already had their geometry prepared for use in rendering shadow volumes?

Definition at line 121 of file OgreEntity.h.

Matrix4* Ogre::Entity::mBoneWorldMatrices`[protected]`

Cached bone matrices, including any world transform.

Definition at line 154 of file OgreEntity.h.

Matrix4* Ogre::Entity::mBoneMatrices`[protected]`

Cached bone matrices in skeleton local space, might shares with other entity instances.

Definition at line 156 of file OgreEntity.h.

unsigned short Ogre::Entity::mNumBoneMatrices`[protected]`

Definition at line 157 of file OgreEntity.h.

unsigned long Ogre::Entity::mFrameAnimationLastUpdated`[protected]`

Records the last frame in which animation was updated.

Definition at line 159 of file OgreEntity.h.

unsigned long* Ogre::Entity::mFrameBonesLastUpdated`[protected]`

Records the last frame in which the bones was updated It's a pointer because it can be shared between different entities with a shared skeleton.

Definition at line 167 of file OgreEntity.h.

EntitySet* Ogre::Entity::mSharedSkeletonEntities`[protected]`

A set of all the entities which shares a single SkeletonInstance.

This is only created if the entity is in fact sharing it's SkeletonInstance with other Entities.

Definition at line 174 of file OgreEntity.h.

bool Ogre::Entity::mDisplaySkeleton`[protected]`

Flag determines whether or not to display skeleton.

Definition at line 180 of file OgreEntity.h.

bool Ogre::Entity::mHardwareAnimation`[protected]`

Flag indicating whether hardware animation is supported by this entities materials.

Definition at line 182 of file OgreEntity.h.

ushort Ogre::Entity::mHardwarePoseCount`[protected]`

Number of hardware poses supported by materials.

Definition at line 184 of file OgreEntity.h.

bool Ogre::Entity::mVertexProgramInUse`[protected]`

Flag indicating whether we have a vertex program in use on any of our subentities.

Definition at line 186 of file OgreEntity.h.

int Ogre::Entity::mSoftwareAnimationRequests`[protected]`

Counter indicating number of requests for software animation.

Definition at line 188 of file OgreEntity.h.

int Ogre::Entity::mSoftwareAnimationNormalsRequests`[protected]`

Counter indicating number of requests for software blended normals.

Definition at line 190 of file OgreEntity.h.

ushort Ogre::Entity::mMeshLodIndex`[protected]`

The LOD number of the mesh to use, calculated by _notifyCurrentCamera.

Definition at line 194 of file OgreEntity.h.

Real Ogre::Entity::mMeshLodFactorInv`[protected]`

LOD bias factor, inverted for optimisation when calculating adjusted depth.

Definition at line 197 of file OgreEntity.h.

ushort Ogre::Entity::mMinMeshLodIndex`[protected]`

Index of minimum detail LOD (NB higher index is lower detail).

Definition at line 199 of file OgreEntity.h.

ushort Ogre::Entity::mMaxMeshLodIndex`[protected]`

Index of maximum detail LOD (NB lower index is higher detail).

Definition at line 201 of file OgreEntity.h.

Real Ogre::Entity::mMaterialLodFactorInv`[protected]`

LOD bias factor, inverted for optimisation when calculating adjusted depth.

Definition at line 204 of file OgreEntity.h.

ushort Ogre::Entity::mMinMaterialLodIndex`[protected]`

Index of minimum detail LOD (NB higher index is lower detail).

Definition at line 206 of file OgreEntity.h.

ushort Ogre::Entity::mMaxMaterialLodIndex`[protected]`

Index of maximum detail LOD (NB lower index is higher detail).

Definition at line 208 of file OgreEntity.h.

LODEntityList Ogre::Entity::mLodEntityList`[protected]`

Definition at line 216 of file OgreEntity.h.

SkeletonInstance* Ogre::Entity::mSkeletonInstance`[protected]`

This Entity's personal copy of the skeleton, if skeletally animated.

Definition at line 220 of file OgreEntity.h.

bool Ogre::Entity::mInitialised`[protected]`

Has this entity been initialised yet?

Definition at line 223 of file OgreEntity.h.

Matrix4 Ogre::Entity::mLastParentXform`[protected]`

Last parent xform.

Definition at line 226 of file OgreEntity.h.

size_t Ogre::Entity::mMeshStateCount`[protected]`

Mesh state count, used to detect differences.

Definition at line 229 of file OgreEntity.h.

ChildObjectList Ogre::Entity::mChildObjectList`[protected]`

Definition at line 260 of file OgreEntity.h.

AxisAlignedBox Ogre::Entity::mFullBoundingBox`[mutable, protected]`

Bounding box that 'contains' all the mesh of each child entity.

Definition at line 264 of file OgreEntity.h.

ShadowRenderableList Ogre::Entity::mShadowRenderables`[protected]`

Definition at line 266 of file OgreEntity.h.

String Ogre::MovableObject::mName`[protected, inherited]`

Name of this object.

Reimplemented in Ogre::Camera.

Definition at line 104 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

Creator of this object (if created by a factory).

Definition at line 106 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

SceneManager holding this object (if applicable).

Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

node to which this object is attached

Definition at line 110 of file OgreMovableObject.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

Definition at line 111 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

Is this object visible?

Definition at line 113 of file OgreMovableObject.h.

bool Ogre::MovableObject::mDebugDisplay`[protected, inherited]`

Is debug display enabled?

Definition at line 115 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

Upper distance to still render.

Definition at line 117 of file OgreMovableObject.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

Definition at line 118 of file OgreMovableObject.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

Hidden because of distance?

Definition at line 120 of file OgreMovableObject.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

User defined link to another object / value / whatever.

Definition at line 122 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

The render queue to use when rendering this object.

Definition at line 124 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 126 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

Flags determining whether this object is included / excluded from scene queries.

Definition at line 128 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

Flags determining whether this object is visible (compared to SceneManager mask).

Definition at line 130 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

Cached world AABB of this object.

Reimplemented in Ogre::ParticleSystem.

Definition at line 132 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

Definition at line 134 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

World space AABB of this object's dark cap.

Definition at line 136 of file OgreMovableObject.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

Does this object cast shadows?

Definition at line 138 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

Does rendering this object disabled by listener?

Definition at line 141 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

MovableObject listener - only one allowed (no list) for size & performance reasons. */.

Definition at line 143 of file OgreMovableObject.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

List of lights for this object.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 146 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

The last frame that this light list was updated in.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 148 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

Default query flags.

Definition at line 152 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

Default visibility flags.

Definition at line 154 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

Static map of class name to list of animable value names.

Definition at line 236 of file OgreAnimable.h.

The documentation for this class was generated from the following file:

- OgreEntity.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:33:10 2009